clear
set more 1
set memory 100m

local a `1'
local table `2'

global whichlist

if "`table'"=="9" {
 global whichlist 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
}
else if inlist("`table'","7","8") {
 global whichlist  51 52 53 54 50
}
else if inlist("`table'","0","1") {
 forvalues i = 301/304 {
  global whichlist $whichlist `i'
 }
}
else if inlist("`table'","10","11") {
 forvalues i = 311/315 {
  global whichlist $whichlist `i'
 }
}
else {
 exit
}


tokenize $whichlist
use f`1'`a',clear
local j = 2
while "``j''" != "" {
 append using f``j''`a'
 local j = `j'+1
}


gen len = length(which)
if inlist("`table'","11")  {
 drop if substr(which,len-1,2)=="_3"
}
else if inlist("`table'","0","1") {
 drop if substr(which,len-1,2)!="_0"
}
drop len

encode which, gen(w)
gen k = _n
sum k
local totk = `r(N)'
global alist_v
forvalues k = 1/`totk' {
 local w : label w `k'
 di "`w'"
 global alist_v $alist_v `w'
}
gsort -pv
global slist_v
matrix slist_p = J(1,`totk',0)
forvalues k = 1/`totk' {
 foreach v in $alist_v {
  qui count if which =="`v'" in `k'
  if `r(N)'!=0 {
   global slist_v $slist_v `v'
   qui sum pv if which =="`v'" in `k'
   matrix slist_p[1,`k'] = `r(mean)'
  }
 }
}

di "$alist_v"
di "$slist_v"
matrix list slist_p

gsort -pv
gen pbon = pv*_n
format pbon %4.3f

sort pv
sum pv
local n = `r(N)'
forvalues i = 1/`n' {
 sum pbon in 1/`i'
 replace pbon = min(`r(max)',1) in `i'
}

sort pv
save fadj`a',replace

 gen se = abs(est/sqrt(fs))

 gen str6 cat = ""
 replace cat = "0"+substr(which,2,1) if substr(which,3,1)=="_"
 replace cat = substr(which,2,2) if substr(which,3,1)!="_"
 replace cat = "60" if cat=="50"

 replace est = -est if substr(which,length(which),1)=="3" 
 replace est = -est if (inrange(real(cat),50,60) | inrange(real(cat),101,115) | inlist(real(cat),0,1,2,5))

 replace cat = cat+substr(which,length(which),1)+substr(which,1,1)
 sort cat
 global w : word count $whichlist
 mkmat est se pv
 local i = 1
 forvalues w=1/$w {
  if `i'==1 {
   capture log close
   qui log using ../outputs/ftest`table'.log, text replace
   di "which,est,se,pv"
  }
  forvalues j=1/6 {
   if pv[`i',1]<.05 {
    local star "*"
   }
   else {
    local star ""
   }
   tokenize $whichlist
   di "``w'' `j'," %4.3f est[`i',1] "`star'," %4.3f se[`i',1] "," %4.3f pv[`i',1] 
   local i = `i'+1
  }
  if $w==`w' {
   qui log off
  }
 }

if inlist("`table'","0","10") {
 qui log close

 gen pv4 = pv
 format %4.3f est se ndpv
 format %5.4f pv4
 l which est se pv4 pv pbon ndpv , clean noobs

 exit
}

foreach k in $whichlist {
 use ft`k'`a',clear
 sort k
 save,replace
}



tokenize $whichlist
if "`1'"=="301" {
 local jm 0
}
if "`1'"=="311" {
 local jm 2
}
use ft`1'`a',clear
local j = 2
while "``j''" != "" {
 merge k using ft``j''`a'
 keep if _m==3
 drop _m
 sort k
 local j = `j'+1
}

mvencode *fs*, mv(100)

local j = 1
while "``j''" != "" {
 foreach es in e s {
  forvalues i=0/`jm' {
   gen `es'``j''_`i' = ttail(`es'``j''df`i',sqrt(`es'``j''fs`i'))*2
  }
 }
 local j = `j'+1
}


local tk1 = `totk'+1
gen q`tk1' = 1
local k = `totk'
foreach v in $slist_v {
 gen boot`k' = (`v'<=slist_p[1,(`totk'-`k'+1)])
 qui sum boot`k'
 scalar pboot`k' = `r(mean)'
 local k = `k'-1
}
tempfile f
save `f'

drop _all
set obs `totk'
gen which = ""
gen pboot = .
gen pv=.
local k = `totk'
foreach v in $slist_v {
 replace which = "`v'" in `k'
 replace pv = slist_p[1,(`totk'-`k'+1)] in `k'
 replace pboot = pboot`k' in `k'
 local k = `k'-1
}

gsort -pboot
global blist_v
matrix blist_p = J(1,`totk',0)
matrix clist_p = J(1,`totk',0)
forvalues k = 1/`totk' {
 foreach v in $alist_v {
  qui count if which =="`v'" in `k'
  if `r(N)'!=0 {
   global blist_v $blist_v `v'
   qui sum pboot if which =="`v'" in `k'
   matrix blist_p[1,`k'] = `r(mean)'
   qui sum pv if which =="`v'" in `k'
   matrix clist_p[1,`k'] = `r(mean)'
  }
 }
}

use `f',clear

local k = `totk'
foreach v in $blist_v {
 sort `v'
 tempvar b
 gen `b' = (_n-.5)/_N 
 by `v':egen `v'_b = mean(`b') 
 local kp1 = `k'+1
 gen q`k' = min(q`kp1',`v'_b)
 gen count`k' = (q`k'<=blist_p[1,(`totk'-`k'+1)])
 qui sum count`k'
 scalar ptil`k' = `r(mean)'
 local k = `k'-1
}
scalar ptil0 = 0

forvalues k = 1/`totk' {
 local km1 = `k'-1
 scalar ptil`k' = max(ptil`k',ptil`km1')
}

sum k

*l k if k+1!=k[_n+1]
*exit

use fadj`a',clear
gen pboot = .
gen padj = .
sort pv
forvalues k = 1/`totk' {
 replace pboot = pboot`k' in `k'
}
sort pboot
forvalues k = 1/`totk' {
 replace padj = ptil`k' in `k'
}
sort pv
gen pfdr = (_n/_N)*.05

gsort -pboot
gen pbbon = pboot*_n
sort pboot
sum pboot
local n = `r(N)'
forvalues i = 1/`n' {
 sum pbbon in 1/`i'
 replace pbbon = min(`r(max)',1) in `i'
}

format pv pboot %5.4f
format pbon pbbon padj %4.3f

order pv pboot pbon pbbon padj
gen sortorder = padj
replace sortorder = -10 if which=="e50_1"
replace sortorder = -9  if which=="e50_2"
replace sortorder = -8  if which=="s50_1"
replace sortorder = -7  if which=="s50_2"
replace sortorder = -6  if which=="e52_1"
replace sortorder = -5  if which=="e52_2"
replace sortorder = -4  if which=="s52_2"
replace sortorder = -3  if which=="e53_1"
replace sortorder = -2  if which=="s53_1"
replace sortorder = -1  if which=="e54_2"
replace sortorder = -.5 if which=="s54_2"
sort sortorder
qui log on
l which p*, clean noobs
qui log close
