clear
set more 1
set memory 400m

use ../ema
gen sa = (svy_adult==1 | svy_break==1)
keep if sa==1 & wt_a!=0
replace svy_age_imp = 2001-year(svy_dob_i)
keep famid
bys famid: gen sib = _N
bys famid: keep if _n==1

capture program drop fbs
program define fbs
 preserve
 sort famid
 keep famid sib 
 gen cid = _n
 gen ra_group = real(substr(famid,2,1))
 compress
 save bsa/s${k},replace
 global k = $k+1
 restore
end

set seed 987654345
global k 0
bootstrap "fbs" k=($k), reps(10000) dots
