set more 1
set matsize 2000

global which `1'
local repb `2'
local repe `3'
global ifx `4'
global del `5'
global ay  `6'
local a `7'

global tf   local/ftest`a'
global tfe  local/fteste`a'
global tfs  local/ftests`a'
global tfx  local/ftestx`a'
global memhold memhold`a'
global pfile ft${which}`a'
global ffile f${which}`a'

do ylist


clear
set memory 400m
use ../ema

foreach v of varlist x_ad_ag* { 
 sort famid `v'
 by famid: replace `v' = `v'[1]
}
replace x_ch_male =  (svy_gender=="M" & svy_sample=="CH")
gen x_one = 1
foreach v of varlist x_* {
 gen x`v' = `v'
 replace x`v' = 0 if x`v'==.
 gen xm_`v' = 0
 replace xm_`v' = `v' if svy_gender=="M" & svy_sample=="CH"
 gen xf_`v' = 0
 replace xf_`v' = `v' if svy_gender=="F" & svy_sample=="CH"
}


keep if svy_sample=="$ay"

if "$ay"=="CH" {
 keep if (sm_ye!=.|sm_yp!=.|sm_ym!=.|sm_yo!=.) & wt_y!=0
}

sort famid svy_sample ppid
by famid svy_sample: gen kid2 = _n!=1
by famid svy_sample: gen sib = _n
replace sib = 1 if svy_sample=="AD"

if ("${ifx}" =="" | "${ifx}" =="nox") {
 global xlist *one*
}
else {
 global xlist *
}

local k : word count $ylist
global gl 1
global gu `k'
gen n = `k'
expand n
bys ppid: replace n = _n

if ("$ay" =="AD") {
 gen wt_tot = wt_a
}
else if ("$ay" =="CH") {
 gen wt_tot = wt_y
}

local i = 1
gen outcome = .
foreach v of varlist $ylist {
 qui replace outcome = `v' if n==`i'
 gen z_`i'_0 = cond(n==`i',ra_group!=3,0)
 gen z_`i'_1 = cond(n==`i',svy_gender=="F" & ra_group!=3,0)
 gen z_`i'_2 = cond(n==`i',svy_gender=="M" & ra_group!=3,0)
 foreach x of varlist xx_$xlist { 
  gen x`x'_`i'_0 = cond(n==`i',`x',0) 
 }
 foreach x of varlist xf_$xlist { 
  gen x`x'_`i'_1 = cond(n==`i',`x',0) 
 }
 foreach x of varlist xm_$xlist { 
  gen x`x'_`i'_2 = cond(n==`i',`x',0) 
 }
 di `i'
 local i = `i'+1
 qui compress
 di "`v'"
}
if "$ay"=="AD" {
 drop xxx_c*
}

gen include_ec = ra_group!=2
gen include_sc = ra_group!=1


gen p=. 
gen est=. 
gen se=.

gen sdat=0
sum sdat
local nn = `r(N)'
keep if outcome!=.
sort famid sib n
save ${tf},replace
keep if ra_group!=2
keep outcome z* x* wt_tot famid svy_gender2 sib n ra_group include*
sort famid sib n
save ${tfe},replace
use ${tf},clear
keep if ra_group!=1
keep outcome z* x* wt_tot famid svy_gender2 sib n ra_group include*
sort famid sib n
save ${tfs},replace

use ${tf},clear

capture program drop readtf
program define readtf
 local es `1'
 if "`es'"=="e" {
  local incl 2
 }
 if "`es'"=="s" {
  local incl 1
 }
 if "$ay"=="AD" {
  local ay a
 }
 else {
  local ay
 }
 use bs`ay'/s${k} if ra_group!=`incl',clear 
 expand sib
 bys cid: replace sib = _n
 global nrange = -${gl}+${gu}+1
 expand $nrange
 bys cid sib: gen n = _n-1+${gl}
 sort famid sib n
 merge famid sib n using ${tf`es'}
 keep if _m==3
end

capture program drop ft
program define ft

 preserve
 global k = `1'

 if "$ay"=="AD" {
  local jm 0
 }
 else { 
  local jm 2
 }
 forvalues j=0/`jm' {
  global z`j'
  global g`j' 0
  global h`j' 0
  global nd`j' 
  forvalues i=${gl}/${gu} {
   global z`j' ${z`j'} *_`i'_`j'
   global g`j' ${g`j'} + _b[z_`i'_`j']
   global nd`j' ${nd`j'} z_`i'_`j'
  }
 }
 foreach es in e s {
  readtf `es'
  scalar num = -${gl} +${gu} + 1
  gen outcome2 = outcome
  if "${ifx}" == "qx" {
   forvalues j=0/`jm' {
    if `j'==0 {
     local sg
    }
    else {
     local sg & (svy_gender2==(`j'-1))
    }      
    global z`j'
    forvalues i=1/1 {
     global z`j' ${z`j'} z_`i'_`j'_r
     qui mvreg (outcome z_`i'_`j') = (x*_`i'_`j') [aw=wt_tot]  if n==`i' `sg', nocon
     predict o_`i'_`j'_r, resid equation(outcome)
     predict z_`i'_`j'_r, resid equation(z_`i'_`j')
     if `j'==0 {
      replace outcome = o_`i'_`j'_r if n==`i' `sg'
      global kx =(e(k)+1) * num
     }
     else {
      replace outcome2 = o_`i'_`j'_r if n==`i' `sg'
      global kx2 = (e(k)+1) * 2 * num
     }
     replace z_`i'_`j'_r = 0 if !(n==`i' `sg')
    }
   }
  }

  reg outcome ${z0} [pw=wt_tot] if include_`es'c==1 & inrange(n,${gl},${gu}), cluster(cid) nocons
  if "$ifx"=="qx" {
   scalar adjust = (e(N)-$kx)/(e(N)-e(df_m))
  }
  else {
   scalar adjust = 1
  }

  test ${nd0}
  scalar `es'_nd0 = r(F) * adjust
  scalar `es'_nddf0 = r(df) 

  test (${g0})/num =  `es'_null0
  scalar `es'_est0 = (${g0})/num 
  scalar `es'_df0 = r(df_r) 
  scalar `es'_fs0 = r(F) * adjust

  if "$ay" != "AD" {
   reg outcome2 ${z1} ${z2} [pw=wt_tot] if include_`es'c==1 & inrange(n,${gl},${gu}), cluster(cid) nocons
   if "$ifx"=="qx" {
    scalar adjust2 = (e(N)-$kx2)/(e(N)-e(df_m))
   }
   else {
    scalar adjust2 = 1
   }
   test ${nd1}
   scalar `es'_nd1 = r(F) * adjust
   scalar `es'_nddf1 = r(df) 

   test (${g1})/num =  `es'_null1
   scalar `es'_est1 = (${g1})/num 
   scalar `es'_df1 = `r(df_r)' 
   scalar `es'_fs1 = r(F) * adjust2

   test ${nd2}
   scalar `es'_nd2 = r(F) * adjust
   scalar `es'_nddf2 = r(df)  

   test (${g2})/num =  `es'_null2
   scalar `es'_est2 = (${g2})/num 
   scalar `es'_df2 = `r(df_r)' 
   scalar `es'_fs2 = r(F) * adjust2

   test ${nd1} ${nd2}
   scalar `es'_nd3 = r(F) * adjust
   scalar `es'_nddf3 = r(df) 

   test ((${g1})-(${g2}))/num = `es'_null3
   scalar `es'_est3 = ((${g1})-(${g2}))/num 
   scalar `es'_df3 = r(df_r)
   scalar `es'_fs3 = r(F) * adjust2
  }
 }
 scalar k = $k
 if "$k"!="0" {
  post $memhold $bl
 }


 restore
end

if "$ay"=="AD" {
 local jm 0
}
else { 
 local jm 3
}

global bs k
global bl (k) 
foreach es in e s {
 forvalues i = 0/`jm' {
  scalar `es'_null`i' = 0
  foreach v in est fs df {
   global bs $bs `es'${which}`v'`i' 
   global bl $bl (`es'_`v'`i') 
  }
 }
 forvalues i = 0/`jm' {
  foreach v in nd nddf {
   global bs $bs `es'${which}`v'`i' 
   global bl $bl (`es'_`v'`i') 
  }
 }
}


ft 0 

drop _all
if "$ay" == "AD" {
 set obs 2
}
else {
 set obs 8
}
gen str5 which = ""
foreach v in est fs df nd nddf {
 gen `v' = .
}
local k 1
foreach es in e s {
 forvalues i = 0/`jm' {
  scalar `es'_null`i' = `es'_est`i'
  scalar `es'_nfs`i' = `es'_fs`i'
  scalar `es'_ndf`i' = `es'_df`i'
  foreach v in est fs df {
   replace `v' = `es'_`v'`i' in `k'
  }
  replace which = "`es'${which}_`i'" in `k'
  local k = `k'+1
 }
}
gen pv = ttail(df,sqrt(fs))*2

local k 1
foreach es in e s {
 forvalues i = 0/`jm' {
  scalar `es'_nnd`i' = `es'_nd`i'
  scalar `es'_nnddf`i' = `es'_nddf`i'
  foreach v in nd nddf {
   replace `v' = `es'_`v'`i' in `k'
  }
  local k = `k'+1
 }
}
gen ndpv = nFtail(nddf,df,0,nd)
save $ffile,replace

use ${tf},clear
postfile $memhold $bs using $pfile, replace every(1)
forvalues k = `repb'/`repe' {
 capture qui ft `k'
 noisily di $k
}
postclose $memhold

scalar list
