
clear
set mem 400m
set more 1

global logdir outputs

use ema, clear
capture drop inter*
*** only keep adults ***
keep if svy_sample == "AD" & inlist(svy_final_disp,"1T","1F","16") == 1
count

gen compmove2 = mm_spmove_x_all>=3  if svy_cmove==1 & mm_spmove_x_all!=.

tab ra_group svy_cmove [aw=wt_totsvy], row
tab ra_group mm_spmove_all [aw=wt_totsvy], row
tab ra_group mm_spmove_all [aw=wt_totsvy] if svy_cmove==0& ra_group!=3, row
tab ra_group compmove2 [aw=wt_totsvy], row

*** Set Graph Defaults ***
graph set eps logo off

global width 2
replace mm_c9000t_perpov_avg = mm_c9000t_perpov_avg*100

*
*** densities ***
gen new_weight = wt_totsvy

*first define totx
gen totx=_n-1 in 1/101

kdensity mm_c9000t_perpov_avg if ra_group==1 & svy_cmove==0 [aw=new_weight], gen(exp_non) at(totx) width($width) ylabel(0(0.01)0.06) ytitle("Fraction") xlabel(0(10)100) xtitle("Experimental Group Non-Compliers") nodraw
label variable exp_non "Experimental Group Non-Compliers"

kdensity mm_c9000t_perpov_avg if ra_group==1 & svy_cmove==1 [aw=new_weight], gen(exp_comp) at(totx) width($width) ylabel(0(0.01)0.06) ytitle("Fraction") xlabel(0(10)100) xtitle("Experimental Group Compliers")  nodraw
label variable exp_comp "Experimental Group Compliers"

kdensity mm_c9000t_perpov_avg if ra_group==2 & svy_cmove==0 [aw=new_weight], gen(s8_non) at(totx) width($width) ylabel(0(0.01)0.06) ytitle("Fraction") xlabel(0(10)100) xtitle("Section 8 Group Non-Compliers")  nodraw
label variable s8_non "Section 8 Group Non-Compliers"

kdensity mm_c9000t_perpov_avg if ra_group==2 & svy_cmove==1 [aw=new_weight], gen(s8_comp) at(totx) width($width) ylabel(0(0.01)0.06) ytitle("Fraction") xlabel(0(10)100) xtitle("Section 8 Group Compliers")  nodraw
label variable s8_comp "Section 8 Group Compliers"

kdensity mm_c9000t_perpov_avg if ra_group==3 [aw=new_weight], gen(control) at(totx) width($width) ylabel(0(0.01)0.06) ytitle("Fraction") xlabel(0(10)100) xtitle("Control Group")  nodraw
label variable control "Control Group"

sum svy_cmove [aw=new_weight] if ra_group==1
scalar exp_scale=r(mean)
sum svy_cmove [aw=new_weight] if ra_group==2
scalar s8_scale=r(mean)

scatter exp_comp s8_comp exp_non s8_non control totx, c(l l l l l) msymbol(none none none none none) clpattern(shortdash_dot longdash_dot dot dash solid) graphregion(fcolor(white) lcolor(white) ) ysize(3.8) xsize(6.7) clwidth(medium medium medium medium medium) clcolor(black black black black black) ytitle("Density") xtitle("Average Poverty Rate")  legend(order(1 3 2 4 5) holes(5)) 
graph export outputs/fig1.eps, replace



