**** Creates a graph in Stata of employment by calendar quarter for each group.
# delimit ;
global logdir outputs;
use ui_calgraph,clear;
gen tmp_qtr = (abs_year - 1960)*4 + abs_qtr-1;
gen tmp_date = mdy((abs_qtr-1)*3 + 1, 1, abs_year);
label var tmp_qtr "Calendar Quarter";
label var ragroup_1 "Experimental";
label var ragroup_2 "Section 8";
label var ragroup_3 "Control";
format tmp_qtr %tq;
format tmp_date %ty;
*       msymbol(triangle square circle ) mcolor(black black black) ;
scatter ragroup_1 ragroup_2 ragroup_3 tmp_date, 
        c(direct direct direct) 
        msymbol(none none none)
        clpattern(solid dash dot)
        graphregion(fcolor(white) lcolor(white) ) ysize(3.8) xsize(6.7)
        clwidth(medium medium medium)
        clcolor(black black black) 
        ylabel(.25 (.05).55, nogrid) 
        xlabel(12784 13149 13515 13880 14245 14610 14976, format(%dCY)) 
        xmlabel(12874 12965 13057 13240 13331 13423 13605 13696 13788 13970 14061 14153 
             14335 14426 14518 14701 14792 14884 15066 15157 15249, format(%dq)) 
        legend(position(6) region(lcolor(black) fcolor(none) ) )
        ytitle("Employment Rate") xtitle("Calendar Year and Quarter");
graph export ${logdir}/fig3.eps, replace;
;
