clear
set memory 400m
set more 1

global logname outputs/table_a2

use ema if inlist(svy_sample,"CH"), clear
replace svy_age_i = 2001 - year(svy_dob_i)
drop if  !(svy_youth==1|svy_child==1|svy_break==1) |wt_totsvy==0  |!inrange(svy_age_i,15,20)


capture program drop startlog
program define startlog
 capture log close
 qui log using $logname, replace text
 di "    FE,   FS,   FC,   ME,   MS,   MC,"
 qui log off
end

capture program drop xc
program define xc
 local x `1'
 local wt wt_totsvy
 local restrict = "inrange(svy_age_i,`2',`3') & inlist(x_ch_male,0,1)"
 reg `x' rag_*  [pw=`wt'] if `restrict' & `x'_miss==0, nocon cluster(famid)
 foreach g in e s {
  foreach i in 0 1 {
   test rag_`g'`i' = rag_c`i'
   if r(p)<=.05 {
    local star`g'`i' = "*"
   }
   else {
    local star`g'`i' = " "
   }
  }
 }


 qui log on 
 foreach i in 0 1 {
  foreach g in e s c {
   di %6.2f  _b[rag_`g'`i'] "`star`g'`i''," _c
  }
 }
 di "  `2' `3' `4' `x'"
 qui log off
 
end

replace x_ch_male = svy_gender=="M" if inlist(svy_gender,"F","M")

gen rag_e0 = ra_group==1 & x_ch_male==0
gen rag_s0 = ra_group==2 & x_ch_male==0
gen rag_c0 = ra_group==3 & x_ch_male==0
gen rag_e1 = ra_group==1 & x_ch_male==1
gen rag_s1 = ra_group==2 & x_ch_male==1
gen rag_c1 = ra_group==3 & x_ch_male==1

gen x_ch_specmed_miss = !inlist(x_ch_specmed,0,1)
gen x_c1_schcll_miss = !inlist(x_c1_schcll,0,1)
gen x_cblack_miss = svy_race==.

startlog

global vlist x_cblack x_c1_gifted x_c1_lrnprb x_c1_behprb x_ch_schplay x_ch_specmed x_c1_schcll x_c1_expel 
foreach v in $vlist {
 xc `v' 15 20 ""
}

qui log close

