clear 
set more 1
set memory 400m


global ylist2 w_status_emp_ad w_earn_2001_ad cc_selfsuf_ad cc_tanf cc_inc_gov2001_ad h_ment_distk6z_ad h_ment_depprobadl2_y_bad h_ment_anxiety_y_ad h_ment_calm h_ment_sleep_78hrs h_hlth_fairpoor_ad h_adl_lim h_asma_y_ad h_bmi2_obese_ad h_bp2_hi_msr       

capture program drop smlog
program define smlog
 local ay `1'
 tempvar y 
 gen `y' = 0
 qui log on
 foreach g in F M {
  foreach v of varlist $ylist2 sm_`1'`2' {
   local pm -
   if inlist("`v'","w_status_emp_ad","w_earn_2001_ad","cc_selfsuf_ad","h_ment_calm","h_ment_sleep_78hrs")| inlist("`v'","ontrack","notidle","wjr_br_wz_a","wjr_bm_wz_a") | substr("`v'",1,3)=="sm_" {
    local pm 
   }
   if "`ay'"=="a" & "`g'"=="F" {
    qui sum `v' [aw=wt_`ay'] if ra_group==3
    qui replace `y' = cond(`v'!=.,`pm'((`v'-r(mean))/r(sd)),.)
    qui replace `y' = cond(substr("`v'",1,3)=="sm_",`v',`y')
    di "`v'," _c
    if substr("`v'",1,3)=="sm_" {
     di ",,," _c
    }
    else { 
     qui reg `v' ra_grp* [aw=wt_`ay']
     global estar = cond(tprob(e(df_r),_b[ra_grp_e]/_se[ra_grp_e])<.05,"*","")
     global sstar = cond(tprob(e(df_r),_b[ra_grp_s]/_se[ra_grp_s])<.05,"*","")
     di %4.2f _b[_cons] "," %4.2f _b[ra_grp_e] "$estar," %4.2f _b[ra_grp_s] "$sstar," _c 
    }
    qui reg `y' ra_grp* [aw=wt_`ay'] 
    global estar = cond(tprob(e(df_r),_b[ra_grp_e]/_se[ra_grp_e])<.05,"*","")
    global sstar = cond(tprob(e(df_r),_b[ra_grp_s]/_se[ra_grp_s])<.05,"*","")
    di %4.2f _b[_cons] "," %4.2f _b[ra_grp_e] "$estar," %4.2f _b[ra_grp_s] "$sstar" _c 
    di
   }
   if "`ay'"=="y" {
    qui sum `v' [aw=wt_`ay'] if ra_group==3 & svy_gender=="`g'"
    qui replace `y' = cond(`v'!=.,`pm'((`v'-r(mean))/r(sd)),.) if svy_gender=="`g'"
    qui replace `y' = cond(substr("`v'",1,3)=="sm_",`v',`y') if svy_gender=="`g'"
    di "`v' `g'," _c
    if substr("`v'",1,3)=="sm_" {
     di ",,," _c
    }
    else { 
     qui reg `v' ra_grp* [aw=wt_`ay'] if svy_gender=="`g'"
     global estar = cond(tprob(e(df_r),_b[ra_grp_e]/_se[ra_grp_e])<.05,"*","")
     global sstar = cond(tprob(e(df_r),_b[ra_grp_s]/_se[ra_grp_s])<.05,"*","")
     di %4.2f _b[_cons] "," %4.2f _b[ra_grp_e] "$estar," %4.2f _b[ra_grp_s] "$sstar," _c 
    }
    qui reg `y' ra_grp* [aw=wt_`ay'] if svy_gender=="`g'"
    global estar = cond(tprob(e(df_r),_b[ra_grp_e]/_se[ra_grp_e])<.05,"*","")
    global sstar = cond(tprob(e(df_r),_b[ra_grp_s]/_se[ra_grp_s])<.05,"*","")
    di %4.2f _b[_cons] "," %4.2f _b[ra_grp_e] "$estar," %4.2f _b[ra_grp_s] "$sstar" _c 
    di
   }
  }
 }
 qui log off
end

use ema,clear

capture program drop startlog
program startlog
 capture log close
 qui log using outputs/table_b1, text replace
 di "descrip,cm,ec,sc,cm_s,ec_s,sc_s"
 qui log off
end
startlog

smlog a o 

qui log close

!more outputs/tabA1.log


