set matsize 2000
set more 1

global which `1'
local repb `2'
local repe `3'
global ifx `4'
global del `5'
local a `6'
global subg `7'

global tf   local/ftest`a'
global tfe  local/fteste`a'
global tfs  local/ftests`a'
global tfx  local/ftestx`a'
global memhold memhold`a'
global pfile ft${which}`a'
global ffile f${which}`a'




do ylist
global ylist $ylist2


clear
set memory 400m
use ../ema if svy_sample=="AD" & (svy_adult==1|svy_break==1)
capture drop x_i_*
gen sib=1

local k : word count $ylist
global gl 1
global gu `k'
gen n = `k'
expand n
bys ppid: replace n = _n

if "$subg"!="" {
 global do12 yes
 gen subg_1 = 1-$subg
 gen subg_2 = 1-subg_1
}
else {
 global do12 no
 gen subg_1=1
}

gen wt_tot=wt_totsvy
gen outcome = .

foreach v in w_status_emp_ad w_earn_2001_ad cc_selfsuf_ad h_ment_calm h_ment_sleep_78hrs {
 qui qui replace `v' = -`v'
}

quietly {
 local i = 1
 foreach v of varlist $ylist {
  replace outcome = -`v' if n==`i'
  local i = `i'+1
 }
 gen z_0 = (ra_group!=3)
 if "$do12"=="yes" {
  gen z_1 = subg_1 * (ra_group!=3)
  gen z_2 = subg_2 * (ra_group!=3)
 }
 gen include_ec = ra_group!=2
 gen include_sc = ra_group!=1
}

if $which== 43 {
 replace wt_tot = wt_totmsr if inlist(n,5)
}
if $which== 44 {
 replace wt_tot = wt_totmsr if inlist(n,10)
}
if $which== 45 {
 replace wt_tot = wt_totmsr if inlist(n,7)
}
if $which== 48 {
 replace wt_tot = wt_totmsr if inlist(n,9,10)
}
if $which== 49 {
 replace wt_tot = wt_totmsr if inlist(n,25,26)
}
if $which== 38 {
 replace wt_tot = wt_totmsr if inlist(n,5)
}
if $which== 39 {
 replace wt_tot = wt_totmsr if inlist(n,15)
}

if $which== 202 {
 replace wt_tot = wt_totnobs if inlist(n,3)
}

if $which== 204 {
 replace wt_tot = wt_totnobs if inlist(n,3,4)
}

gen p=. 
gen est=. 
gen se=.

keep if outcome!=.
sort famid sib n
save ${tf},replace
keep if ra_group!=2
keep outcome z* x* wt_tot famid sib n ra_group include* subg*
save ${tfe},replace
use ${tf},clear
keep if ra_group!=1
keep outcome z* x* wt_tot famid sib n ra_group include* subg*
save ${tfs},replace

use ${tf},clear

capture program drop readtf
program define readtf
 local es `1'
 if "`es'"=="e" {
  local incl 2
 }
 if "`es'"=="s" {
  local incl 1
 }
 use bs/s${k} if ra_group!=`incl',clear 
 expand sib
 bys cid: replace sib = _n
 global nrange = -${gl}+${gu}+1
 expand $nrange
 bys cid sib: gen n = _n-1+${gl}
 sort famid sib n
 merge famid sib n using ${tf`es'}
 keep if _m==3
end

capture program drop ft
program define ft
 preserve
 global k = `1'
 forvalues j=0/2 {
  global z`j'
  global g`j' 0
  global h`j' 0
  global nd`j'
  forvalues i=${gl}/${gu} {
   global g`j' ${g`j'} + _b[z_`i'_`j']/s_`i'_`j'
   global h`j' ${h`j'} + _b[z_`i'_`j']/sqrt(_b[s_0_`i'_`j']) 
   global nd`j' ${nd`j'} z_`i'_`j'
  }
 }
 foreach es in e s {
  readtf `es'
  gen s0=.
  gen s2=.
  forvalues i=${gl}/${gu} {
   reg outcome [pw=wt_tot] if include_`es'c==1 & n==`i' & ra_group==3
   scalar dn = `e(N)'/`e(df_r)'
   tempvar rv
   predict `rv' if include_`es'c==1 & n==`i' & ra_group==3,resid
   replace s0 = (`rv')^2*dn if include_`es'c==1 & n==`i' & ra_group==3

   if "$do12" =="yes" {
    reg outcome z_1 z_2 subg_1 subg_2 [pw=wt_tot] if include_`es'c==1 & n==`i', nocon
    scalar dn = (`e(N)'/`e(df_r)')
    tempvar rv
    predict `rv' if include_`es'c==1 & n==`i' & ra_group==3,resid
    replace s2 = (`rv')^2*dn if include_`es'c==1 & n==`i' & ra_group==3
   }
  }

  forvalues i=${gl}/${gu} {
   reg s0  [pw=wt_tot] if include_`es'c==1 & n==`i' & ra_group==3
   scalar s_`i'_0 = sqrt(_b[_cons])
   if (s_`i'_0==0) {
    sum s0 [aw=wt_tot] if if include_`es'c==1 & n==`i' & ra_group==3 
    scalar p = 2/(`r(N)'+4)
    scalar s_`i'_0 = sqrt(p * (1-p))
   }

   if "$do12"=="yes" {
    reg s2 subg_1 subg_2 [pw=wt_tot] if include_`es'c==1 & n==`i', nocon
    scalar s_`i'_1 = sqrt(_b[subg_1])
    if (s_`i'_0<=0) {
     sum subg_1 [aw=wt_tot] if include_`es'c==1 & n==`i' & s2!=.
     scalar p = 2/((r(N)*r(mean))+4)
     scalar s_`i'_1 = sqrt(p * (1-p))
    }
    scalar s_`i'_2 = sqrt(_b[subg_2])
    if (s_`i'_2<=0) {
     sum subg_2 [aw=wt_tot] if include_`es'c==1 & n==`i' & s2!=.
     scalar p = 2/((r(N)*r(mean))+4)
     scalar s_`i'_2 = sqrt(p * (1-p))
    }
   }

   if "$which" == "49" {
    if inrange(`i',1,6) {
     scalar s_`i'_0 = s_`i'_0 / (23/(6*3))
    }
    else if inrange(`i',7,13) {
     scalar s_`i'_0 = s_`i'_0 / (23/(7*3))
    }
    else if inrange(`i',14,23) {
     scalar s_`i'_0 = s_`i'_0 / (23/(10*3))
    }
   }
  }
  

  scalar num = -${gl} +${gu} + 1
  gen outcome0 = .
  gen outcome2 = .
  if "$do12"=="yes" {
   local jmax 1
  }
  else {
   local jmax 0
  }
  global z0
  global z1
  global z2
  forvalues j=0/`jmax' {
   forvalues i=${gl}/${gu} {
    if `j'==0 {
     global z`j' ${z`j'} z_`i'_`j'_r
     qui mvreg (outcome z_`j') = (x_*) [aw=wt_tot] if n==`i' 
     predict z_`i'_`j'_r if n==`i', resid equation(z_`j')
     predict o_`i'_`j'_r if n==`i', resid equation(outcome)
     replace outcome0 = o_`i'_`j'_r if n==`i'
     global kx =(e(k)+1) * num
     replace z_`i'_0_r = 0 if !(n==`i' )
    }
    else {
     global z1 ${z1} z_`i'_1_r
     global z2 ${z2} z_`i'_2_r
     qui mvreg (outcome z_1 z_2) = (subg_1 subg_2 x_*) [aw=wt_tot] if n==`i' , nocon
     predict z_`i'_1_r if n==`i', resid equation(z_1)
     predict z_`i'_2_r if n==`i', resid equation(z_2)
     predict o_`i'_2_r if n==`i', resid equation(outcome)
     replace outcome2 = o_`i'_2_r if n==`i' 
     global kx2 = (e(k)+1) * 2 * num
     replace z_`i'_1_r = 0 if !(n==`i' )
     replace z_`i'_2_r = 0 if !(n==`i' )
    }
   }
  }
  
  reg outcome0 ${z0} [pw=wt_tot] if include_`es'c==1 & inrange(n,${gl},${gu}), cluster(cid) nocons
  scalar adjust = (e(N)-$kx)/(e(N)-e(df_m))

  test ${nd0}
  scalar `es'_nd0 = r(F) * adjust
  scalar `es'_nddf0 = r(df)
 
  test (${g0})/num =  `es'_null0
  scalar `es'_est0 = (${g0})/num 
  scalar `es'_fs0 = r(F) * adjust
  scalar `es'_df0 = r(df_r) 

  if "$do12"=="yes" {
   reg outcome2 ${z1} ${z2} [pw=wt_tot] if include_`es'c==1 & inrange(n,${gl},${gu}), cluster(cid) nocons
   scalar adjust2 = (e(N)-$kx2)/(e(N)-e(df_m))
   test (${g1})/num =  `es'_null1
   scalar `es'_est1 = (${g1})/num 
   scalar `es'_df1 = `r(df_r)' 
   scalar `es'_fs1 = r(F) * adjust2
   test (${g2})/num =  `es'_null2
   scalar `es'_est2 = (${g2})/num 
   scalar `es'_df2 = `r(df_r)' 
   scalar `es'_fs2 = r(F) * adjust2
   test ((${g1})-(${g2}))/num = `es'_null3
   scalar `es'_est3 = ((${g1})-(${g2}))/num 
   scalar `es'_df3 = r(df_r)
   scalar `es'_fs3 = r(F) * adjust2
  }
 } 
 scalar k = $k
 if "$k"!="0" {
  post $memhold $bl
 }
 restore
end

global bs k
global bl (k) 
foreach es in e s {
 if "$do12"=="yes" {
  global up 3
 }
 else {
  global up 0
 }
 forvalues i = 0/$up {
  scalar `es'_null`i' = 0
  foreach v in est fs df {
   global bs $bs `es'${which}`v'`i' 
   global bl $bl (`es'_`v'`i') 
  }
 }
 if "${del}" !="del" { 
  forvalues i = 0/0 {
   foreach v in nd nddf {
    global bs $bs `es'${which}`v'`i' 
    global bl $bl (`es'_`v'`i') 
   }
  }
 }
}

ft 0 

drop _all
set obs 8
gen str5 which = ""
foreach v in est fs df nd nddf {
 gen `v' = .
}
local k 1
foreach es in e s {
 forvalues i = 0/$up {
  scalar `es'_null`i' = `es'_est`i'
  scalar `es'_nfs`i' = `es'_fs`i'
  scalar `es'_ndf`i' = `es'_df`i'
  foreach v in est fs df {
   replace `v' = `es'_`v'`i' in `k'
  }
  replace which = "`es'${which}_`i'" in `k'
  local k = `k'+1
 }
}
gen pv = ttail(df,sqrt(fs))*2

local k 1
foreach es in e s {
 forvalues i = 0/0 {
  scalar `es'_nnd`i' = `es'_nd`i'
  scalar `es'_nnddf`i' = `es'_nddf`i'
  foreach v in nd nddf {
   replace `v' = `es'_`v'`i' in `k'
  }
  local k = (`k')+4
 }
}
gen ndpv = nFtail(nddf,df,0,nd)

save $ffile,replace

use ${tf},clear
postfile $memhold $bs using $pfile, replace every(1)
forvalues k = `repb'/`repe' {
 capture qui ft `k'
 noisily di $k
}
postclose $memhold

scalar list
