clear
set more 1
set mem 300m


/*
#delimit ;
cd ~/data_natl/nlsy97/DelinquentBehavior;

infile using outcomes.dct;

*drop non-interviews;
drop if R3828400 < 0;

*compute age based on round 3 interview date and birthdate--note exact day 
	of birth unreported;
*computed as number of months between Round 3 interview and birthdate;
gen nv_age = ((R3828402*12 + R3828401) - (R3828302*12 + R3828301))/12;

*limit to those 15+;
drop if nv_age<15;

*****Additional variables (mostly from Round 3) added on 1/8/2004;

 *R3881500 is enrollment/graduation status;
 
 *new variable for graduated from high school, earned GED, or currently 
	enrolled;
 gen nv_sch = 0;
 replace nv_sch = 1 if R3881500>1;
 replace nv_sch = . if R3881500<0;
 
 *R3703900 is currently employed;

 *new variable for employed or enrolled in school;
 gen nv_empORsch = 0;
 replace nv_empORsch = 1 if R3703900==1|R3881500>7;
 replace nv_empORsch=. if R3881500<0;

 *R3482000/R3482100 height variables (first is feet/second is inches);
 *new variables for height;
 gen nv_ht_ft = R3482000;
 gen nv_ht_in = R3482100;
 replace nv_ht_ft = . if nv_ht_ft <0;
 replace nv_ht_in = . if nv_ht_in <0;

 *R3482200 body weight in pounds;
 *new variable for weight;
 gen nv_weight = R3482200;
 replace nv_weight = . if nv_weight<0;

 *R3481900 is general health;
 *categories are 1=Excellent/2=Very Good/3=Good/4=Fair/5=Poor;
 *new variable for general health;
 gen nv_health = R3481900;
 replace nv_health = . if nv_health<0;

***next four variables come from round 1 and are only instances of
	these questions;

 *R0320900 is number of days eat green vegetables?;
 
 *R0321000 is number of days exercise 30 minutes or more;

 *R0686800 is whether youth covered by health insurance and what type? (Asked of parent);
 
 *R0322400 is for a handful of youth without parental respondent who were asked of 
	their own health insurance coverage;
 
*****End of additional variables from 1/8/2004;

rename R3923700 wt_surv; 
egen wt_sum = sum(wt_surv);
replace wt_surv = wt_surv/wt_sum;
rename R1193000 famid;

*responding parents ID;
gen par_id = R0735000;
*flag for those without a responding parent;
gen f_nopar = 0;
replace f_nopar = 1 if par_id < 0;

*RACE AND ETHNICITY;
*here i've grouped "mixed" with other;
gen nv_blk = R3828600==2;
gen nv_wh = R3828600==1;
gen nv_na = R3828600==3;
gen nv_asian = R3828600==4;
gen nv_oth = R3828600==5;
replace nv_oth = 1 if R3828600==7;
gen nv_hisp = R3828500==1;
replace nv_hisp = 1 if R3828600==6;

*FEMALE INDICATOR;
gen nv_fem = R3828700==2;

****SEXUAL ACTIVITY;
*ever had sex as of round 3 defined as ever reported having had sex;
gen nv_sex_evr = 0;
replace nv_sex_evr = 1 if R0349700 ==1 | R2182900==1 | R3500800==1;
replace nv_sex_evr = 1 if R2183000==1 | R3500900==1;

*here I note everyone who did not report on sex in round 3;
*this includes some people who reported having had sex earlier but 
	it also has some people who reported not having sex earlier 
	but may have since.  This avoids overstating the proportion;
replace nv_sex_evr = . if R3500800 < 0 & R3500900 < 0;

*did youth have sex when age 14 or younger?;
gen agesex1st = max(R0349800, R2183200, R3501100);
replace agesex1st = 100 if nv_sex_evr==0;
*one person has two different answers for age first time had sex;
*since reported having sex before being as old as the greater of 
	these two (18), i've used the lesser of the two (14);
replace agesex1st = min(R0349800, R3501100) if R0349800>0 & R3501100>0;
gen nv_sex_bf14 = (agesex1st<=14);
*recode some observations as missing for same reason as 
	nv_sex_evr variable;
replace nv_sex_bf14 = . if agesex1st < 0 |nv_sex_evr==.;

*approximate number of sex partners in last year using SDLI;
gen nv_sex_partnr_xy = R3501800;
*for some nlsy observations only estimate is available;
*for these i use the midpoint of the range they reported;
replace nv_sex_partnr_xy = 3.5 if R3501900==2;    
replace nv_sex_partnr_xy = 7.5 if R3501900==3;
replace nv_sex_partnr_xy = 10 if R3501900==4;
replace nv_sex_partnr_xy = . if nv_sex_partnr_xy<0;
*recode number of sex partners last year as 0 for those who didn't 
	have sex last year;
replace nv_sex_partnr_xy = 0 if R3500800==0 | R3500900==0;
*reported having had sex only once;
replace nv_sex_partnr_xy = 1 if R3500900==1 & R3501500==0;

*2 or more sex partners?;
gen nv_sex_partnr_2xy=(nv_sex_partnr_xy>1);
replace nv_sex_partnr_2xy = . if nv_sex_partnr_xy==.;

****PREGNANCY;
*ever pregnant or gotten someone pregnant as of round 3;
gen nv_preg_evr = 0;
*have you ever been pregnanat? (asked of females);
replace nv_preg_evr = 1 if R0351200==1 | R2185000==1 | R3502900==1;
replace nv_preg_evr = 1 if R2185100==1 | R3503000==1;
*have you ever gotten someone pregnant? (asked of males);
replace nv_preg_evr = 1 if R2188200==1 | R3507200==1;
replace nv_preg_evr = 1 if R3507300==1;
replace nv_preg_evr = . if R3502900 < 0 & R3503000 < 0 & nv_fem==1;
replace nv_preg_evr = . if R3507200 < 0 & R3507300 < 0 & nv_fem==0;

*if never had sex, not asked pregnancy questions;
replace nv_preg_evr = 0 if nv_sex_evr==0 & nv_preg_evr==.;
*similarly, if didn't have sex SDLI, won't have been asked 
	pregnancy questions;
replace nv_preg_evr = 0 if nv_preg_evr==. & R3502900==-4 & 
	R3503000==-4 & R3500900==0 & R0351200~=1 & R2185000~=1 
	& R2185100~=1;

*compute live births for females and males separately due to 
	different skip pattern;
*live births for females;
gen nv_livebirth_x = max(R0352200, R2185600, R3503500) if nv_fem==1;
replace nv_livebirth_x = 0 if nv_livebirth_x < 0;
*tack on births that happened between 1st and 2nd rounds;
replace nv_livebirth_x = nv_livebirth_x + R2185900 if R2185900 > 0;
*tack on births that happened between 2nd and 3rd rounds;
replace nv_livebirth_x = nv_livebirth_x + R3503800 if R3503800 > 0;
*missing if didn't answer sex questions, or answered sex==yes but 
	not pregnancy, or answered pregnancy==yes but not live birth;
replace nv_livebirth_x = . if (nv_sex_evr==. | nv_preg_evr==. | 
	(R3502900==1 & (R3503400~=0 & R3503500<0)) | (R3503000==1 & 
	(R3503700~=0 & R3503800<0) & (R3503400~=0 & R3503500<0))) 
	& nv_fem==1;
*missings due to skip pattern;
replace nv_livebirth_x = . if (R2185600==-1 | R2185600==-2) & R3503500<0;
replace nv_livebirth_x = . if (R2185900==-1 | R2185900==-2) & R3503500<0;

*live births for males;
replace nv_livebirth_x = max(R2188700, R3507800) if nv_fem==0;
replace nv_livebirth_x = 0 if nv_livebirth_x < 0;
*missing due to refusal in round 2 and skip pattern in following year;
replace nv_livebirth_x = . if (R2188700==-1|R2188700==-2) & R3507800 < 0;
replace nv_livebirth_x = . if nv_preg_evr==.;
*missing if answered pregnancy==yes but not live birth;
replace nv_livebirth_x = . if ((R3507200==1 | R3507300==1) & R3507700~=0 
	& R3507600~=0 & R3507800<0) & nv_fem==0;

gen nv_livebirth_evr = (nv_livebirth_x>=1);
replace nv_livebirth_evr = . if nv_livebirth_x==.;

****SMOKING;
*ever smoked as of round 3 defined as ever reported having smoked;
gen nv_smk_evr = 0;
replace nv_smk_evr = 1 if R0357900 ==1 | R2189100==1 | R3508200==1;
replace nv_smk_evr = 1 if R2189400==1 | R3508500==1;

*here I note everyone who did not report on smoking in round 4;
*this includes some people who reported smoking earlier but it also has 
	some people who reported not smoking earlier but may have since.  
	This avoids overstating the proportion;
replace nv_smk_evr = . if R3508200 < 0 & R3508500 < 0;

*smoking behavior variables;
gen days_smk = R3508600;
replace days_smk = . if days_smk < 0;
replace days_smk = 0 if R3508200==0 | R3508500==0;
gen cig_day = R3508700;
replace cig_day = . if cig_day < 0;
replace cig_day = 0 if R3508200==0 | R3508500==0 | days_smk==0;
gen nv_smk_fdm = days_smk/30;
gen nv_smk_m = (days_smk>=1);
replace nv_smk_m = . if days_smk==.;
gen nv_smk_avgpd = (cig_day*days_smk)/30;
gen nv_smk_2xpd = (nv_smk_avgpd>=2);
replace nv_smk_2xpd = . if nv_smk_avgpd==.;

****ALCOHOL;
*ever drank as of round 3 defined as ever reported drinking;
gen nv_alc_evr = 0;
replace nv_alc_evr = 1 if R0358300 ==1 | R2189900==1 | R3509000==1;
replace nv_alc_evr = 1 if R2190200==1 | R3509300==1;

*here I note everyone who did not report on drinking in round 3;
*this includes some people who reported drinking earlier but it also has 
	some people who reported not drinking earlier but may have since.  
	This avoids overstating the proportion;
replace nv_alc_evr = . if R3509000 < 0 & R3509300 < 0;

*drinking behavior variables;
gen days_alc = R3509400;
replace days_alc = . if days_alc < 0;
replace days_alc = 0 if R3509000==0 | R3509300==0;
gen drk_day = R3509500;
replace drk_day = . if drk_day < 0;
replace drk_day = 0 if R3509000==0 | R3509300==0 | days_alc==0;
gen nv_alc_fdm = days_alc/30;
gen nv_alc_m = (days_alc>=1);
replace nv_alc_m = . if days_alc==.;
gen nv_alc_avgpd = (days_alc*drk_day)/30;

*binge drinking;
gen days_alc_5more = R3509600;
replace days_alc_5more = . if days_alc_5more < 0;
replace days_alc_5more = 0 if R3509000==0 | R3509300==0 | days_alc==0;
gen nv_alc5_fdm = days_alc_5more/30;
gen nv_alc5_m = (days_alc_5more>=1);
replace nv_alc5_m = . if days_alc_5more==.;

gen nv_alc_b4sch_fdm = R3509700/30;
replace nv_alc_b4sch_fdm = . if nv_alc_b4sch_fdm < 0;
replace nv_alc_b4sch_fdm = 0 if R3509000==0 | R3509300==0 | days_alc==0;

****MARIJUANA;
*ever smoked pot as of round 3 defined as ever reported having smoked pot;
gen nv_pot_evr = 0;
replace nv_pot_evr = 1 if R0358900 ==1 | R2190900==1 | R3510000==1;
replace nv_pot_evr = 1 if R2191200==1 | R3510300==1;

*here I note everyone who did not report on smoking pot in round 3;
*this includes some people who reported smoking pot earlier but it also 
	has some people who reported not smoking pot earlier but may have 
	since.  This avoids overstating the proportion;
replace nv_pot_evr = . if R3510000 < 0 & R3510300 < 0;

*marijuana behavior variables;
gen days_pot = R3510400;
replace days_pot = . if days_pot < 0;
replace days_pot = 0 if R3510000==0 | R3510300==0;
gen nv_pot_fdm = days_pot/30;
gen nv_pot_m = (days_pot>=1);
replace nv_pot_m = . if days_pot==.;

gen nv_pot_b4sch_fdm = R3510500/30;
replace nv_pot_b4sch_fdm = . if nv_pot_b4sch_fdm < 0;
replace nv_pot_b4sch_fdm = 0 if R3510000==0 | R3510300==0 | days_pot==0;

****HARD DRUGS;
*ever used hard or other drugs?;
gen nv_odrg_evr = 0;
replace nv_odrg_evr = 1 if R2191500==1 | R3510800==1;
replace nv_odrg_evr = 1 if R3511100==1;
replace nv_odrg_evr = . if R3511100 < 0 & R3510800 < 0;

*hard and other drug behavior;
gen nv_odrg_xy = R3511200;
replace nv_odrg_xy = . if nv_odrg_xy < 0;
replace nv_odrg_xy = 0 if R3510800==0 | R3511100==0;
gen nv_odrg_y = (nv_odrg_xy >=1);
replace nv_odrg_y = . if nv_odrg_xy==.;

****GUNS;
*ever carried a handgun as of round 3;
gen nv_gun_evr = 0;
replace nv_gun_evr = 1 if R0359800==1 | R2193100==1 | R3512700==1;
replace nv_gun_evr = 1 if R0360000==1 | R2193400==1 | R3513000==1;
replace nv_gun_evr = . if R3512700< 0 & R3513000< 0;

*carried handgun in last year;
gen nv_gun_y = (R3513000==1);
replace nv_gun_y = . if R3513000<0;
replace nv_gun_y = 0 if R3512700==0;

****GANG MEMBERSHIP;
*ever belong to gang as of round 3;
gen nv_gang_evr = 0;
replace nv_gang_evr = 1 if R0360500==1 | R2194100==1 | R3513700==1;
replace nv_gang_evr = 1 if R2194400==1 | R3514000==1;
replace nv_gang_evr = . if R3513700 < 0 & R3514000 < 0;

*belonged to gang in last year;
gen nv_gang_y = (R3514000==1);
replace nv_gang_y = . if R3514000 < 0;
replace nv_gang_y = 0 if R3513700==0;

****VIOLENT ATTACKS;
*ever attack to hurt or fight as of round 3;
gen nv_atk_evr = 0;
replace nv_atk_evr = 1 if R0361300==1 | R2196000==1 | R3515600==1;
replace nv_atk_evr = 1 if R2196100==1 | R3515700==1;
replace nv_atk_evr = . if R3515600 < 0 & R3515700 < 0;

*attacks in last year;
gen nv_atk_xy = R3518700;
replace nv_atk_xy = . if nv_atk_xy < 0;
replace nv_atk_xy = 0 if R3515600==0 | R3515700==0;
gen nv_atk_y = (nv_atk_xy>=1);
replace nv_atk_y = . if nv_atk_xy==.;

****SELLING DRUGS;
*ever sell or help sell drugs as of round 3;
gen nv_seldrg_evr = 0;
replace nv_seldrg_evr = 1 if R0361400==1 | R2196300==1 | R3515900==1;
replace nv_seldrg_evr = 1 if R2196400==1 | R3516000==1;
replace nv_seldrg_evr = . if R3515900 < 0 & R3516000 < 0;

*drug-selling behavior;
gen nv_seldrg_xy = R3519200;
replace nv_seldrg_xy = . if R3519200 < 0;
replace nv_seldrg_xy = 0 if R3515900==0 | R3516000==0;
gen nv_seldrg_y = (nv_seldrg_xy>=1);
replace nv_seldrg_y = . if nv_seldrg_xy==.;

****ARRESTS;
*ever been arrested as of round 3;
gen nv_arst_evr = 0;
replace nv_arst_evr = 1 if R0365900==1 | R2200100==1 | R3519700==1;
replace nv_arst_evr = 1 if R2200300==1 | R3519900==1;
replace nv_arst_evr = . if R3519700 < 0 & R3519900 < 0;

*arrest history;
gen nv_arst_xy = R3520100;
replace nv_arst_xy = . if R3520100 < 0;
replace nv_arst_xy = 0 if R3519700==0 | R3519900==0;
gen nv_arst_y = (nv_arst_xy>=1);
replace nv_arst_y = . if nv_arst_xy==.;

****ADDITIONAL VARIABLES COMPRISING DELINQUENCY INDEX;
*ever purposely destroy property as of round 3;
gen nv_dest_evr = 0;
replace nv_dest_evr = 1 if R0360900==1 | R2194800==1 | R3514400==1;
replace nv_dest_evr = 1 if R2194900==1 | R3514500==1;
replace nv_dest_evr = . if R3514400 < 0 & R3514500 < 0;

*ever steal anything less than 50 dollars;
gen nv_less50_evr = 0;
replace nv_less50_evr = 1 if R0361000==1 | R2195100==1 | R3514700==1;
replace nv_less50_evr = 1 if R2195200==1 | R3514800==1;
replace nv_less50_evr = . if R3514700 < 0 & R3514800 < 0;

*ever steal anything more than 50 dollars;
gen nv_more50_evr = 0;
replace nv_more50_evr = 1 if R0361100==1 | R2195400==1 | R3515000==1;
replace nv_more50_evr = 1 if R2195500==1 | R3515100==1;
replace nv_more50_evr = . if R3515100 < 0 & R3515000 < 0;

*ever commit other property crime;
gen nv_prop_evr = 0;
replace nv_prop_evr = 1 if R0361200==1 | R2195700==1 | R3515300==1;
replace nv_prop_evr = 1 if R2195800==1 | R3515400==1;
replace nv_prop_evr = . if R3515300 < 0 & R3515400 < 0;

*delinquency index;
gen nv_deliq_indx = ((nv_gun_evr==1) + (nv_gang_evr==1) + (nv_atk_evr==1) 
	+ (nv_seldrg_evr==1) + (nv_arst_evr==1) + (nv_dest_evr==1) + 
	(nv_less50_evr==1) + (nv_more50_evr==1) + (nv_prop_evr==1))/9; 
*recode as missing if 5 or more elements of index are missing;
gen num_miss = (nv_gun_evr==.) + (nv_gang_evr==.) + (nv_atk_evr==.) + 
	(nv_seldrg_evr==.) + (nv_arst_evr==.) + (nv_dest_evr==.) + 
	(nv_less50_evr==.) + (nv_more50_evr==.) + (nv_prop_evr==.); 
replace nv_deliq_indx = . if num_miss>=5;

****EXTENDED COVARIATES;
*generate age of household members as of first round interview;
gen hh2age = ((R0000202*12 + R0000201) - (R1085202*12 + R1085201))/12;
gen hh3age = ((R0000202*12 + R0000201) - (R1085302*12 + R1085301))/12;
gen hh4age = ((R0000202*12 + R0000201) - (R1085402*12 + R1085401))/12;
gen hh5age = ((R0000202*12 + R0000201) - (R1085502*12 + R1085501))/12;
gen hh6age = ((R0000202*12 + R0000201) - (R1085602*12 + R1085601))/12;
gen hh7age = ((R0000202*12 + R0000201) - (R1085702*12 + R1085701))/12;
gen hh8age = ((R0000202*12 + R0000201) - (R1085802*12 + R1085801))/12;
gen hh9age = ((R0000202*12 + R0000201) - (R1085902*12 + R1085901))/12;

gen nv_ad_age = (par_id==2)*hh2age + 
	(par_id==3)*hh3age + (par_id==4)*hh4age + 
	(par_id==5)*hh5age + (par_id==6)*hh6age + (par_id==7)*hh7age + 
	(par_id==8)*hh8age + (par_id==9)*hh9age;

*recode those where parent did not respond as 0 and flag;
*also flag those where adult's age in Round 1 is less than child's age
	in Round 3, suggesting incorrect parent ID or birthdate;
gen f_ad_age = 0;
replace f_ad_age = 1 if (nv_ad_age>150 | nv_ad_age<nv_age) & f_nopar==0;
replace nv_ad_age = 0 if nv_ad_age>150 | nv_ad_age<nv_age;

gen nv_ad_19_29 = (nv_ad_age>=19)*(nv_ad_age<30);
gen nv_ad_30_39 = (nv_ad_age>=30)*(nv_ad_age<40);
gen nv_ad_40_49 = (nv_ad_age>=40)*(nv_ad_age<50);

*generate highest educational attainment of household members;
gen hh2ed = R1099500;
gen hh3ed = R1099600;
gen hh4ed = R1099700;
gen hh5ed = R1099800;
gen hh6ed = R1099900;
gen hh7ed = R1100000;
gen hh8ed = R1100100;
gen hh9ed = R1100200;

gen nv_ad_ed = (par_id==2)*hh2ed + 
	(par_id==3)*hh3ed + (par_id==4)*hh4ed + 
	(par_id==5)*hh5ed + (par_id==6)*hh6ed + (par_id==7)*hh7ed + 
	(par_id==8)*hh8ed + (par_id==9)*hh9ed;

*recode those where parent did not respond as 0 and flag;
gen f_ad_ed = 0;
replace f_ad_ed = 1 if nv_ad_ed<0 & f_nopar==0;
replace nv_ad_ed = 0 if nv_ad_ed<0;

*completed at least 12 grades of school, comparable to MTO variable 
	for have GED or HS diploma;
gen nv_ad_gedhs = (nv_ad_ed>=12)*(nv_ad_ed<90);

*generate marital status of household members;
gen hh2mar = R1104300;
gen hh3mar = R1104400;
gen hh4mar = R1104500;
gen hh5mar = R1104600;
gen hh6mar = R1104700;
gen hh7mar = R1104800;
gen hh8mar = R1104900;
gen hh9mar = R1105000;

gen nv_ad_mar = (par_id==2)*hh2mar + 
	(par_id==3)*hh3mar + (par_id==4)*hh4mar + 
	(par_id==5)*hh5mar + (par_id==6)*hh6mar + (par_id==7)*hh7mar + 
	(par_id==8)*hh8mar + (par_id==9)*hh9mar;

*code those where parent did not respond as 0 and flag;
gen f_ad_mar = 0;
replace f_ad_mar = 1 if nv_ad_mar<0 & f_nopar==0;

*variable for never married;
gen nv_ad_nomar = (nv_ad_mar==0);

*generate enrollment status of household members;
gen hh2enr = R1093100;
gen hh3enr = R1093200;
gen hh4enr = R1093300;
gen hh5enr = R1093400;
gen hh6enr = R1093500;
gen hh7enr = R1093600;
gen hh8enr = R1093700;
gen hh9enr = R1093800;

*gen nv_ad_enr = (par_id==2)*hh2enr + 
	(par_id==3)*hh3enr + (par_id==4)*hh4enr + 
	(par_id==5)*hh5enr + (par_id==6)*hh6enr + (par_id==7)*hh7enr + 
	(par_id==8)*hh8enr + (par_id==9)*hh9enr;

*recode those where parent did not respond as 0 and flag;
*gen f_ad_enr = 0;
*replace f_ad_enr = 1 if nv_ad_enr<0 & f_nopar==0;
*replace nv_ad_enr = 0 if nv_ad_enr<0;

*generate employment status of household members;
gen hh2emp = R1089900;
gen hh3emp = R1090000;
gen hh4emp = R1090100;
gen hh5emp = R1090200;
gen hh6emp = R1090300;
gen hh7emp = R1090400;
gen hh8emp = R1090500;
gen hh9emp = R1090600;

gen nv_ad_emp = (par_id==2)*hh2emp + 
	(par_id==3)*hh3emp + (par_id==4)*hh4emp + 
	(par_id==5)*hh5emp + (par_id==6)*hh6emp + (par_id==7)*hh7emp + 
	(par_id==8)*hh8emp + (par_id==9)*hh9emp;

*recode those where parent did not respond as 0 and flag;
gen f_ad_emp = 0;
replace f_ad_emp = 1 if nv_ad_emp<0 & f_nopar==0;
replace nv_ad_emp = 0 if nv_ad_emp<0 | nv_ad_emp==2;

*child ever taken remedial class or class for educationally handicapped?;
*taken remedial math or reading?;
gen nv_remed = max(R0679100, R0679101, 0);
*taken special program for educationally handicapped?;
replace nv_remed = 1 if R0679104==1;

*child ever been in program for gifted and talented or specialized magnet program;
*match this with MTO variable for gifted or did advanced work in a subject;
gen nv_gift = max(R0679106, R0679107, 0);

*no refusals for above two variables, so only valid skips are those for whom parent
	did not respond;
*creates flags in case need to use MTO flags;
gen f_gift = 0;
gen f_remed = 0;

*have problems limiting ability to attend school regularly, do school work, or 
	work at a job;
gen nv_disab = (R0681300==1);
*code missings as 0 and flag;
gen f_disab = 0;
replace f_disab = 1 if R0681300<0 & f_nopar==0;

*take medication or prescription drugs for chronic condition?;
gen nv_medic = (R0681400==1);
gen f_medic = 0;
replace f_medic = 1 if R0681400<0 & f_nopar==0;

*did parent or parents spouse receive money from AFDC or ADC last year?;
gen nv_afdc = (R0611300==1);
gen f_afdc = 0;
replace f_afdc = 1 if R0611300<0 & f_nopar==0;

*did parent or parents spouse own any vehicles?;
gen nv_car = (R0621300==1);
gen f_car = 0;
replace f_car = 1 if R0621300<0 & f_nopar==0;

*household size variables;
gen nv_hh_size2 = (R1205400==2);
gen nv_hh_size3 = (R1205400==3);
gen nv_hh_size4 = (R1205400==4);

gen ifmto = 0;

drop R*;

save DelNLS, replace;

clear;


use attacks.dta;

sort ppid;

save ATKtemp, replace;
clear;

use svyout_adch_051303.dta;

sort ppid;

merge ppid using ATKtemp;
drop _m;
sort ppid;
merge ppid using ~/kling/ontrack;

keep if svy_sample=="CH";

*nv_ indicates new variable name so two samples will match;

*generate race variables comparable to what i used for NLS;
gen nv_blk = svy_race==1;
gen nv_wh = svy_race==2;
gen nv_na = svy_race==3;
gen nv_asian = svy_race==4;
gen nv_oth =svy_race==5;
gen nv_hisp = svy_ethnic == 1;

*create year month and day of birth;
gen dob_yr = year(svy_dob_imp);
gen dob_mon = month(svy_dob_imp);
gen dob_day = day(svy_dob_imp);
format svy_dob_imp %d;

*create age as of Dec 31 2001;
gen nv_age = (d(31dec2001) - svy_dob_imp)/365.25;

keep if nv_age >=15;

****create attack ever and number of attacks variables;
*ever attack to hurt or fight;
gen nv_atk_evr = (atak==1);
replace nv_atk_evr = . if atak>2 | atak==.;

*attacks in last year;
gen nv_atk_xy = atakx;
replace nv_atk_xy = . if nv_atk_xy < 0;
replace nv_atk_xy = 0 if nv_atk_evr==0;

gen nv_atk_y = (nv_atk_xy>=1);
replace nv_atk_y = . if nv_atk_xy==.;

gen nv_fem = svy_gender == "F";

gen ifmto = 1;

destring famid, replace;

gen nv_fairpoor = 1-h_hlth_good_sr;
gen nv_obese = h_bmi_ovrwgt_yt;
gen nv_emporsch = 1-w_status_idle_yt;
gen nv_sch = ontrack;

rename r_sex_had_evr nv_sex_evr;
rename r_sex_sex_bf14 nv_sex_bf14;
rename r_sex_partnr_2xy	nv_sex_partnr_2xy;
rename r_sex_partnr_xy nv_sex_partnr_xy;
rename r_sex_preg_evr nv_preg_evr;
rename r_sex_livebirth_evr nv_livebirth_evr;
rename r_sex_livebirth_x nv_livebirth_x;

rename r_smoke_cig_evr nv_smk_evr;
rename r_smoke_cig_2xpd	nv_smk_2xpd;
rename r_smoke_cig_fdm nv_smk_fdm;
rename r_smoke_cig_avgpd nv_smk_avgpd;
rename r_smoke_cig_m nv_smk_m;

rename r_alc_drnk_evr nv_alc_evr;
rename r_alc_drnk_avgpd nv_alc_avgpd;
rename r_alc_drnk_fdm nv_alc_fdm;
rename r_alc_drnk_m nv_alc_m;
rename r_alc_drnk5_fdm nv_alc5_fdm;
rename r_alc_drnk5_m nv_alc5_m;
rename r_alc_b4sch_fdm nv_alc_b4sch_fdm;

rename r_drug_pot_evr nv_pot_evr;
rename r_drug_pot_fdm nv_pot_fdm;
rename r_drug_pot_m nv_pot_m;
rename r_drug_pot_b4sch	nv_pot_b4sch_fdm;

rename r_drug_odrug_evr	nv_odrg_evr;
rename r_drug_odrug_xy nv_odrg_xy;
rename r_drug_odrug_y nv_odrg_y;

rename r_delq_gun_evr nv_gun_evr;
rename r_delq_gun_y nv_gun_y;

rename r_gang_mem_evr nv_gang_evr;
rename r_gang_mem_y nv_gang_y;

rename r_delq_selldrg_evr nv_seldrg_evr;
rename r_delq_selldrg_xy nv_seldrg_xy;
rename r_delq_selldrg_y	nv_seldrg_y;

rename r_delq_arst_evr nv_arst_evr;
rename r_delq_arst_xyr nv_arst_xy;
rename r_delq_arst_y nv_arst_y;

rename r_indx_delinq nv_deliq_indx; 

rename wt_totsvy wt_surv;
egen wt_sum = sum(wt_surv);
replace wt_surv = wt_surv/wt_sum;

*flags--some don't already exist for MTO;
gen f_nopar = 0;
gen f_ad_age = 0;
rename x_ad_edgradhs_miss f_ad_ed;
gen f_ad_enr = 0;
gen f_ad_emp = 0;
gen f_ad_mar = 0;
rename x_ch_schplay_miss f_disab;
gen f_medic = 0;
gen f_afdc = 0;
gen f_car = 0;
rename x_c1_gifted_miss f_gift;
rename x_c1_lrnprb_miss	f_remed;

rename x_ad_19_29 nv_ad_19_29;
rename x_ad_30_39 nv_ad_30_39;
rename x_ad_40_49 nv_ad_40_49;
rename x_ad_edinsch nv_ad_enr;
rename x_ad_working nv_ad_emp;
rename x_ad_nevmarr nv_ad_nomar;
rename x_c1_gifted nv_gift;
rename x_c1_lrnprb nv_remed;
rename x_ch_schplay nv_disab;
rename x_hh_afdc nv_afdc;
rename x_hh_car nv_car;
rename x_hh_size2 nv_hh_size2;
rename x_hh_size3 nv_hh_size3;
rename x_hh_size4 nv_hh_size4;
rename x_ch_specmed nv_medic;

global xlist nv_ad_19_29 nv_ad_30_39 nv_ad_40_49 nv_ad_emp 
	nv_ad_nomar nv_gift nv_remed nv_disab nv_afdc nv_car 
	nv_hh_size2	nv_hh_size3 nv_hh_size4 nv_medic;

*group GED and High School together for consistency with NLSY;
gen nv_ad_gedhs = x_ad_edged + x_ad_edgradhs;

save DelMTO, replace;
#delimit cr;


use ~/data_natl/nlsy97/DelinquentBehavior/DelMTO,clear
append using ~/data_natl/nlsy97/DelinquentBehavior/delnls2

replace nv_fairpoor = (inlist(nv_health,4,5)) if ifmto==0
replace nv_obese = (nv_bmi_pct>95) if nv_bmi_pct!=.&ifmto==0


*race variable for hispanic and all others
gen nv_alloth = max(nv_na,nv_asian,nv_oth,nv_hisp,0)

*whites and blacks nonhispanic
replace nv_wh = 0 if nv_hisp==1
replace nv_blk = 0 if nv_hisp==1


capture program drop lg
program define lg
*http://mathworld.wolfram.com/LegendrePolynomial.html 
 local p   `1'
 local old `2' 
 if "`3'"=="" {
  local new `2'_ 
 }
 else {
  local new `3'_ 
 }
 sum `old',mean
 forvalues i=1/6 {
  capture drop `new'`i'
 }
 gen `new'1 = (`old'-r(min))/(r(max)-r(min))*2 - 1
 if `p'>=2 gen `new'2 = .5*(3*`new'1^2-1)
 if `p'>=3 gen `new'3 = .5*(5*`new'1^3-3*`new'1)
 if `p'>=4 gen `new'4 = .125*(35*`new'1^4-30*`new'1^2+3)
 if `p'>=5 gen `new'5 = .125*(63*`new'1^5-70*`new'1^3+15*`new'1)
 if `p'>=6 gen `new'6 = (1/16)*(231*`new'1^6-315*`new'1^4+105*`new'1^2-5)
end
lg 6 nv_age Lp

gen nv_male = nv_fem==0
*ifmto interacted with male
gen ifmto_male = ifmto*nv_male


global dlist Lp* nv_wh nv_alloth f_nopar 
capture drop g_*
gen g_e = ra_group==1
gen g_s = ra_group==2
gen g_c = ra_group==3
gen g_n = ifmto==0

save table_d1,replace

*/
use table_d1,clear

quietly {
 capture log close
 log using outputs/table_d1, text replace
 log off
}

forvalues m = 0/1 {
 foreach x of varlist $dlist $xlist {
  sum `x' [aw=wt_surv] if ifmto==1 & nv_male==`m', meanonly
  replace `x' = `x'-`r(mean)' if nv_male==`m'
 }
}
forvalues m = 0/1 {
 foreach x of varlist f_nopar {
  sum `x' [aw=wt_surv] if ifmto==0 & nv_male==`m', meanonly
  replace `x' = `x'-`r(mean)' if nv_male==`m'
 }
}


forvalues i = 1/1 {
 qui log on
 di "g_e,g_s,g_c,g_n,m_n,sex,outcome"
 qui log off
}

capture drop nv_seldrg_xy nv_odrg_xy

forvalues m = 0/1 {
 foreach v of varlist nv_pot_m nv_smk_m nv_alc_m nv_preg_evr {
  sum `v' [aw=wt_surv] if ifmto==0 & nv_male==`m', meanonly
  scalar nlsy = `r(mean)'
  qui reg `v' g_n $dlist $xlist [pw=wt_surv] if ifmto==0 & nv_male==`m', cluster(famid) nocon
  scalar nlsyadj = _b[g_n]
  qui reg `v' g_* [pw=wt_surv]  if ifmto==1 & nv_male==`m', cluster(famid) nocon
  qui log on
  di %6.2f _b[g_e] "," %6.2f _b[g_s] "," %6.2f _b[g_c] "," %6.2f nlsyadj ","  %6.2f nlsy ",`m',`v'" 
  qui log off
 }
}

sum nv_gift
local i=`r(max)'
forvalues m = 0/1 {
 foreach v of varlist nv_pot_m nv_smk_m nv_alc_m nv_preg_evr {
  sum `v' [aw=wt_surv] if ifmto==0 & nv_male==`m', meanonly
  scalar nlsy = `r(mean)'
  qui reg `v' g_n $dlist $xlist [pw=wt_surv] if ifmto==0 & nv_male==`m' & nv_gift!=`i', cluster(famid) nocon
  scalar nlsyadj = _b[g_n]
  qui reg `v' g_* [pw=wt_surv]  if ifmto==1 & nv_male==`m' & nv_gift!=`i', cluster(famid) nocon
  qui log on
  di %6.2f _b[g_e] "," %6.2f _b[g_s] "," %6.2f _b[g_c] "," %6.2f nlsyadj ","  %6.2f nlsy ",`m',`v'" 
  qui log off
 }
}


qui log close

* note: nlsyadj in this table does not control for tract poverty rate
*  this analysis was done at BLS, and is described in table_d1a.do
