******

* This file is code for work at the BLS on August 31, 2005 by Jane Fortson
* Using confidential geocoded data to match census tract poverty rate to NLSY97 data
* These results can only be replicated on-site at BLS under special arrangement

******

use "C:\NLS\Users\Princeton\files\NLSYdata.dta"

capture drop *_temp

sort nv_id

merge nv_id using "C:\NLS\Users\Princeton\files\pov_rate_match.dta"

tab _merge

scalar mto_mean_0=.485392 
scalar mto_mean_1=.4977545 

forvalues m = 0/1 {
  replace pov_rate = pov_rate-mto_mean_`m' if nv_male==`m'
}

* then, want to run regression

global xlist nv_ad_19_29 nv_ad_30_39 nv_ad_40_49 nv_ad_emp nv_ad_nomar nv_ad_gedhs nv_gift nv_remed nv_disab nv_afdc nv_car nv_hh_size2	nv_hh_size3 nv_hh_size4 nv_medic

global dlist Lp* nv_wh nv_alloth f_nopar 

generate g_n = (ifmto==0)

quietly {
 capture log close
 log using "C:\NLS\Users\Princeton\files\tableD1.log", text replace
 log off
}


forvalues i = 1/1 {
 qui log on
 di "g_n,m_n,sex,outcome"
 qui log off
}

forvalues m = 0/1 {
 foreach v of varlist nv_pot_m nv_smk_m nv_alc_m nv_preg_evr {
  sum `v' [aw=wt_surv] if ifmto==0 & nv_male==`m', meanonly
  scalar nlsy = `r(mean)'
  qui reg `v' g_n $dlist $xlist pov_rate [pw=wt_surv] if ifmto==0 & nv_male==`m', cluster(famid) nocon
  scalar nlsyadj = _b[g_n]
  qui log on
  di %6.2f nlsyadj ","  %6.2f nlsy ",`m',`v'" 
  qui log off
 }
}


forvalue m=0/1 {
  sum nv_gift if nv_male==`m'
  scalar GIFTED_`m'=r(max)
}
*drop if nv_gift==`r(max)'
forvalues m = 0/1 {
  foreach v of varlist nv_pot_m nv_smk_m nv_alc_m nv_preg_evr {
  sum `v' [aw=wt_surv] if ifmto==0 & nv_male==`m' & nv_gift!=GIFTED_`m', meanonly
  scalar nlsy = r(mean)
  qui reg `v' g_n $dlist $xlist pov_rate [pw=wt_surv] if ifmto==0 & nv_male==`m' & nv_gift!=GIFTED_`m', cluster(famid) nocon
  scalar nlsyadj = _b[g_n]
  qui log on
  di %6.2f nlsyadj ","  %6.2f nlsy ",`m',`v'" 
  qui log off
 }
}

* ORDER IN LOG FILE
*   with pov_rate
* 	including gifted
*    	   girls
*        boys
*	dropping gifted
*        girls
*        boys

qui log close

