clear
set memory 400m
set more 1

global demog "z_age_2001 x_ad_male x_site_balt x_site_bos x_site_chi x_site_la z_site_ny x_ad_race_black x_ad_race_other x_ad_ethn_hisp x_ad_nevmarr x_ad_parentu18" 
global work_ed "x_ad_working x_hh_afdc x_ad_edinsch z_ad_edgradhs z_ad_edged "
global hhld "x_hh_car x_hh_disabl x_hh_victim x_hh_noteens x_hh_size2 x_hh_size3 x_hh_size4"
global hood "x_hood_5y x_hous_mov3tm x_hood_verydissat x_hood_safenit x_hood_chat x_hood_nbrkid x_hood_nofamily x_hood_nofriend" 
global move "x_hous_fndapt x_hous_movdrgs x_hous_movschl x_hous_sec8bef" 


use ppid wt* x* svy* ra* using ema if svy_sample=="AD"

gen x_age = (2001-year(svy_dob_i))/100
gen z_ad_edged = x_ad_edged if x_ad_edgradhs_miss ~= 1
gen z_ad_edgradhs = x_ad_edgradhs if x_ad_edgradhs_miss ~= 1
gen z_site_ny = (ra_site == 5)
gen z_age_2001 = (mdy(12,31,2001) - svy_dob_imp)/365.25



tab svy_sample
expand 2
bys ppid: gen n = _n

forvalues i=1/3 {
 forvalues j=1/2 {
  gen z`i'`j' = (ra_group==`i' & n==`j')
 }
}


gen wtb = wt_totsvy if (svy_break==1|svy_adult==1)
replace wtb = wt_totcore if n==2

foreach a in a {
 capture log close
 qui log using outputs/table_f13, text replace
 di "x,grp,svymean,fullmean"
 qui log off
}

foreach v of varlist $demog $work_ed $hhld $hood $move {
 foreach i in 3 1 2 {
  forvalues j=1/2 {
   qui sum `v' [aw=wtb] if ra_group==`i' & n==`j'
   scalar m`i'`j' = r(mean)
  }
  qui reg `v' z`i'1 z`i'2 [pw=wtb] if ra_group==`i', nocon cluster(ppid)
  qui test z`i'1 - z`i'2 = 0
  global star = cond(r(p)<.05,"*"," ")
  qui log on
  di "`v' , `i' , " %4.2f m`i'1 "," %4.2f m`i'2 "$star"
  qui log off
 }
}

foreach i in 3 1 2 {
 forvalues j=1/2 {
  qui sum ra_site [aw=wtb] if ra_group==`i' & n==`j'
  scalar n`j' = r(N)
 }
 qui log on
 di "N, `i', " %4.0f n1 ", " %4.0f n2
 qui log off
}

qui log close
