clear
set more 1
set memory 400m

global p mm_c9000t_perpov_avg

global ylist_a w_status_emp_ad w_earn_2001_ad cc_selfsuf_ad cc_tanf cc_inc_gov2001_ad h_ment_distk6z_ad h_ment_depprobadl2_y_bad h_ment_anxiety_y_ad h_ment_calm h_ment_sleep_78hrs h_hlth_fairpoor_ad h_adl_lim h_asma_y_ad h_bmi2_obese_ad h_bp2_hi_msr 

global ylist_y ontrack notidle wjr_br_wz_a wjr_bm_wz_a  r_drug_pot_m r_smoke_cig_m r_alc_drnk_m r_sex_preg_evr h_ment_distk6_ch_z h_ment_depr_evr_yt h_ment_gad_evr_yt h_hlth_fairpr_sr h_asma_y_sr injnonsport h_bmi_ovrwgt_yt 

use ema
gen apov30 =   mm_c9000t_perpov_avg>.30 if mm_c9000t_perpov_avg!=.
global t1list  mm_c9000t_perpov_avg  apov30  nb_drg_sawsold_m_ad nb_safe_safnit_ad  m_victim_6mos_nomis mm_c9000t_pwelf_avg  mm_c9000t_pemp_avg  mm_c00t_histatus_avg mm_c9000t_pminorty_avg

qui log using outputs/table_1, replace text
foreach v of varlist $t1list {
 forvalues i = 1/3 {
  qui sum `v' if ra_group==`i' & svy_sample=="AD" & svy_adult==1 [aw=wt_totsvy]
  scalar m`i' = r(mean)
 }
 di %3.2f m1 "," %3.2f m2 "," %3.2f m3 ", `v'" 
}
qui log close

replace w_earn_2001_ad = w_earn_2001_ad / 1000
replace cc_inc_gov2001_ad = cc_inc_gov2001_ad / 1000

foreach v of varlist x_ad_ag* { 
 sort famid `v'
 by famid: replace `v' = `v'[1]
}
replace x_ch_male =  (svy_gender=="M" & svy_sample=="CH")
foreach v of varlist x_* {
 gen x`v' = `v'
 replace x`v' = 0 if x`v'==.
 gen xm_`v' = 0
 replace xm_`v' = `v' if svy_gender=="M" & svy_sample=="CH"
 gen xf_`v' = 0
 replace xf_`v' = `v' if svy_gender=="F" & svy_sample=="CH"
}

global a  svy_sample=="AD"
global y  svy_sample=="CH"
global f  svy_gender=="F" & svy_sample=="CH"
global m  svy_gender=="M" & svy_sample=="CH"

forvalues i=1/5 {
 foreach g in a y f m {
  gen sg`g'_1`i' = (ra_group==1 & ra_site==`i' & ${`g'})
  gen sg`g'_2`i' = (ra_group==2 & ra_site==`i' & ${`g'})
 }
}

foreach g in a y f m {
 gen e`g'_itt = (ra_group==1 & ${`g'}) if ra_group!=2
 gen s`g'_itt = (ra_group==2 & ${`g'}) if ra_group!=1
 gen e`g'_tot = (ra_group==1 & ${`g'} & svy_cmove==1) if ra_group!=2
 gen s`g'_tot = (ra_group==2 & ${`g'} & svy_cmove==1) if ra_group!=1
 gen p`g'_ols  = $p * (${`g'})
 gen p`g'_iv  = $p * (${`g'})
 gen p`g'_iv2 = svy_cmove * (${`g'})
}

scalar de_itt = 0
scalar de_itt_se = 0
scalar de_itt_pv = 0
scalar ds_itt = 0
scalar ds_itt_se = 0
scalar ds_itt_pv = 0

capture program drop startlog
program define startlog
 capture log close
 set linesize 255
 qui log using outputs/ema_log, replace text
 di "eun,eitt,eitt_se,eitt_pv,etot,etot_se,e_tot_pv,e_ccm,en,deitt,deitt_se,deitt_pv," _c
 di "sun,sitt,sitt_se,sitt_pv,stot,stot_se,s_tot_pv,s_ccm,sn,dsitt,dsitt_se,dsitt_pv," _c
 di "ols,ols_se,ols_pv,cmean,cn," _c
 di "pov,pov_se,pov_pv,pov1,pov1_se,pov1_pv,comp,comp_se,comp_pv,pn,afm,y"
 qui log close
end
startlog

capture program drop writeout
program define writeout
   local g `1'
   local y `2'
   qui log using outputs/ema_log, text append
   di %4.3f `g'e_unad "," %4.3f `g'e_itt "$`g'e_itt_st," %4.3f `g'e_itt_se "," %4.3f `g'e_itt_pv "," _c
   di %4.3f `g'e_tot "$`g'e_tot_st," %4.3f `g'e_tot_se "," %4.3f `g'e_tot_pv "," %4.3f `g'eccm "," %4.0f `g'e_tot_n "," _c
   di %4.3f de_itt "$de_itt_st," %4.3f de_itt_se "," %4.3f de_itt_pv "," _c
   di %4.3f `g's_unad "," %4.3f `g's_itt "$`g's_itt_st," %4.3f `g's_itt_se "," %4.3f `g's_itt_pv "," _c
   di %4.3f `g's_tot "$`g's_tot_st," %4.3f `g's_tot_se "," %4.3f `g's_tot_pv "," %4.3f `g'sccm "," %4.0f `g's_tot_n "," _c
   di %4.3f ds_itt "$ds_itt_st," %4.3f ds_itt_se "," %4.3f ds_itt_pv "," _c
   di %4.2f `g'p_ols "$`g'p_ols_st," %4.2f `g'p_ols_se "," %4.2f `g'p_ols_pv "," %4.3f `g'cmean "," %4.0f `g'p_ols_n "," _c
   di %4.2f `g'p_iv "$`g'p_iv_st," %4.2f `g'p_iv_se "," %4.3f `g'p_iv_pv "," _c
   di %4.2f `g'p_iv1 "$`g'p_iv1_st," %4.2f `g'p_iv1_se "," %4.3f `g'p_iv1_pv "," _c
   di %4.2f `g'p_iv2 "$`g'p_iv2_st," %4.2f `g'p_iv2_se "," %4.3f `g'p_iv2_pv ","  %4.0f `g'p_iv_n ",`g',`y'"
   qui log close
end

capture program drop store_ay
program define store_ay
 local esp `1'
 local est `2'
 local y   `3'
 local ay  `4'

 if inlist("`y'","sm_ye","sm_yp","sm_ym","sm_yr","sm_yo") {
  local wt y
 }
 else if ("`y'"=="ontrack") {
  local wt totpoc
 }
 else if (substr("`y'",1,3)=="wjr") {
  local wt totwjr
 }
 else if inlist("`y'","sm_ae","sm_ap","sm_am","sm_ao") {
  local wt a
 }
 else if ("`y'"=="h_bp2_hi_msr") {
  local wt totmsr
 }
 else {
  local wt totsvy
 }

 if ("`est'"=="itt") {
  reg `y' `esp'`ay'_`est'  [pw=wt_`wt'], cluster(famid)
  scalar `ay'`esp'_unad    =  _b[`esp'`ay'_itt]
  reg `y' `esp'`ay'_`est'  xx_* [pw=wt_`wt'], cluster(famid)
 }
 if ("`est'"=="tot") {
  ivreg `y' (`esp'`ay'_`est' = `esp'`ay'_itt) xx_* [pw=wt_`wt'], cluster(famid)
  sum `y' [aw=wt_`wt'] if `esp'`ay'_`est' == 1
  scalar `ay'`esp'ccm = r(mean) - _b[`esp'`ay'_`est']
 }
 if ("`est'"=="ols") {
  reg `y' p`ay'_ols xx_* [pw=wt_`wt'] if ra_group==3, cluster(famid)
  sum `y' [aw=wt_`wt'] if ra_group==3
  scalar `ay'cmean = r(mean)
 }
 if "`est'"=="iv" {
  ivreg `y' (p`ay'_iv = sg`ay'_*) xx_* [pw=wt_`wt'], cluster(famid)
 }
 if "`est'"=="iv2" {
  ivreg `y' (p`ay'_iv p`ay'_iv2 = sg`ay'_*) xx_* [pw=wt_`wt'], cluster(famid)
  scalar `ay'`esp'_iv1    =  _b[`esp'`ay'_iv] 
  scalar `ay'`esp'_iv1_se = _se[`esp'`ay'_iv]
  scalar `ay'`esp'_iv1_pv = (ttail(e(df_r),abs(`ay'`esp'_iv1/`ay'`esp'_iv1_se)))*2
  global `ay'`esp'_iv1_st = (cond(`ay'`esp'_iv1_pv<0.05),"*"," ")
 }
 scalar `ay'`esp'_`est'_n = e(N)
 scalar `ay'`esp'_`est'    =  _b[`esp'`ay'_`est'] 
 scalar `ay'`esp'_`est'_se = _se[`esp'`ay'_`est'] 
 scalar `ay'`esp'_`est'_pv = (ttail(e(df_r),abs(`ay'`esp'_`est'/`ay'`esp'_`est'_se)))*2
 global `ay'`esp'_`est'_st = cond((`ay'`esp'_`est'_pv<0.05),"*"," ")
end


capture program drop store_fm
program define store_fm
 local esp `1'
 local est `2'
 local y   `3'
 if inlist("`y'","sm_ye","sm_yp","sm_ym","sm_yr","sm_yo") {
  local wt y
 }
 else if ("`y'"=="ontrack") {
  local wt totpoc
 }
 else if (substr("`y'",1,3)=="wjr") {
  local wt totwjr
 }
 else {
  local wt totsvy
 }
 if "$wt"!="" {
  local wt tot$wt
 }

 if ("`est'"=="itt") {
  reg `y' `esp'f_`est' `esp'm_`est' x_ch_male [pw=wt_`wt'], cluster(famid)
  scalar f`esp'_unad   = _b[`esp'f_itt]
  scalar m`esp'_unad   = _b[`esp'm_itt]

  reg `y' `esp'f_`est' `esp'm_`est' xf_* xm_* [pw=wt_`wt'], cluster(famid)
  lincom  _b[`esp'm_`est'] - _b[`esp'f_`est']
  scalar d`esp'_itt    = r(estimate)
  scalar d`esp'_itt_se = r(se)
  scalar d`esp'_itt_pv = (ttail(e(df_r),abs(d`esp'_itt/d`esp'_itt_se)))*2
  global d`esp'_itt_st = (cond(d`esp'_itt_pv<0.05),"*"," ")
 }
 if ("`est'"=="tot") {
  ivreg `y' (`esp'f_`est' `esp'm_`est' = `esp'f_itt `esp'm_itt) xf_* xm_* [pw=wt_`wt'], cluster(famid)
  sum `y' [aw=wt_`wt'] if `esp'f_`est' == 1
  scalar f`esp'ccm = r(mean) - _b[`esp'f_`est']
  sum `y' [aw=wt_`wt'] if `esp'm_`est' == 1
  scalar m`esp'ccm = r(mean) - _b[`esp'm_`est']
 }
 if "`est'"=="ols" {
  if "$wt"=="cells" {
   replace pf_ols = $p * svy_gender2
   replace pm_ols = $p * (1-svy_gender2)
   capture drop x_ch_female
   gen x_ch_female = 1-x_ch_male
   reg `y' x_ch_female x_ch_male [pw=wt_`wt'] if ra_group==3, nocon
   scalar fcmean = _b[x_ch_female]
   scalar mcmean = _b[x_ch_male]
  }
  else {
   foreach g in f m {
    replace p`g'_ols = $p * (${`g'})
   }
   sum `y' [aw=wt_`wt'] if ra_group==3 & svy_sample=="CH" & svy_gender=="F"
   scalar fcmean = r(mean)
   sum `y' [aw=wt_`wt'] if ra_group==3 & svy_sample=="CH" & svy_gender=="M"
   scalar mcmean = r(mean)
  }
  reg `y' pf_ols pm_ols xf_* xm_* [pw=wt_`wt'] if ra_group==3, cluster(famid)
 }
 if "`est'"=="iv" {
  ivreg `y' (pf_iv pm_iv = sgf_* sgm_*) xf_* xm_* [pw=wt_`wt'], cluster(famid)
 }
 if "`est'"=="iv2" {
  ivreg `y' (pf_iv pm_iv pf_iv2 pm_iv2 = sgf_* sgm_*) xf_* xm_* [pw=wt_`wt'], cluster(famid)
  foreach g in f m {
   scalar `g'`esp'_iv1    =  _b[`esp'`g'_iv] 
   scalar `g'`esp'_iv1_se = _se[`esp'`g'_iv]
   scalar `g'`esp'_iv1_pv = (ttail(e(df_r),abs(`g'`esp'_iv1/`g'`esp'_iv1_se)))*2
   global `g'`esp'_iv1_st = (cond(`g'`esp'_iv1_pv<0.05),"*"," ")
  }
 }
 foreach g in f m {
  scalar `g'`esp'_`est'_n = e(N)
  scalar `g'`esp'_`est'    =  _b[`esp'`g'_`est'] 
  scalar `g'`esp'_`est'_se = _se[`esp'`g'_`est'] 
  scalar `g'`esp'_`est'_pv = (ttail(e(df_r),abs(`g'`esp'_`est'/`g'`esp'_`est'_se)))*2
  global `g'`esp'_`est'_st = cond((`g'`esp'_`est'_pv<0.05),"*"," ")
 }
end


 global wt 
 foreach y of varlist sm_ae sm_ap sm_am sm_ao $ylist_a {
  quietly {
   store_ay e itt `y' a
   store_ay s itt `y' a
   store_ay e tot `y' a
   store_ay s tot `y' a
   store_ay p ols `y' a
   store_ay p iv  `y' a
   store_ay p iv2 `y' a
  }
  writeout a `y'
 }

 foreach y of varlist sm_yp sm_ym sm_yr sm_ye sm_yo $ylist_y {
  quietly {
   store_ay e itt `y' y
   store_ay s itt `y' y
   store_ay e tot `y' y
   store_ay s tot `y' y
   store_ay p ols `y' y
   store_ay p iv  `y' y
   store_ay p iv2 `y' y
  }
  writeout y `y'
 }


 capture program drop mkrow
 program define mkrow
  local y `1'
  global wt `2'
  quietly {
   store_fm e itt `y'
   store_fm s itt `y'
   store_fm e tot `y'
   store_fm s tot `y'
   store_fm p ols `y'
   store_fm p iv  `y'
   store_fm p iv2 `y'
  }
  writeout f `y'
  writeout m `y'
 end

* Tables 2 & 4
foreach y of varlist sm_yp sm_ym sm_yr sm_ye sm_yo $ylist_y {
 mkrow `y'
}

* Tables 3 & G2
foreach y of varlist $ylist_y {
 mkrow `y'
}

* Table G3
mkrow sn_peer_oldhood  svy
mkrow c00t_perpov_sr   svy
mkrow c00t_pminorty_fr svy
mkrow c00t_pnsnlf_fr   svy
mkrow c00t_histatus_fr svy
mkrow neighsat         svy
mkrow unsafe_n         svy
mkrow discrim          svy
mkrow probs_n          svy
mkrow nb_drg_saw_1xw_ch svy
mkrow nb_vio_hrdshots_1xw_ch svy
mkrow m_victim_6mos_nomis  svy
mkrow nb_vio_sawshot_y_ch  svy
mkrow nb_vio_jump      svy

* Table G4
mkrow houscond         svy
mkrow probs_h          svy
mkrow h_env_int_idxob  hobs
mkrow h_env_ext_idxob  nobs
mkrow sn_adl_vsupp_pcg svy
mkrow knowsall         svy
mkrow unsup            svy
mkrow eatall           svy
mkrow schv             svy
mkrow n_pct_fle_1      pocy
mkrow s_plep_1         pocy
mkrow sc_pct_white_1   pocy
mkrow sc_puptch00_1    pocy
mkrow s_score_1        pocy
mkrow r_att_schclimate svy

* Table G5
mkrow sn_net_closefrnd_pr pocy
mkrow sn_net_frnds_5x_ch  svy
mkrow sn_peer_schlact     svy
mkrow sn_peer_drugs       svy
mkrow sn_peer_weapon      svy 
mkrow sn_peer_gangs       svy
mkrow oldvisit            svy
mkrow goneback            svy
mkrow nb_monit_graffiti_ad svy
mkrow nb_monit_skipsch_ad  svy
mkrow struct               svy
mkrow sn_peer_chrch_1xm    svy
mkrow sn_adl_seedad_1xw    svy
mkrow sn_adl_vsupp_dad     svy
mkrow confid3              svy
mkrow hlpu4                svy

* Table G6
mkrow e_engage_attent      svy
mkrow e_engage_wrkhrd      svy
mkrow e_grades_high        svy
mkrow e_engage_hw_all      svy
mkrow e_engage_hw_5hxw     svy
mkrow e_engage_read_5hw    svy
mkrow e_plans_apsat        svy
mkrow e_track_mathadv      svy
mkrow e_track_giftclass_2y pocy
mkrow e_track_speced_2y    pocy
mkrow e_repeat_evr         pocy
mkrow r_sch_late_1xm       svy
mkrow r_sch_abs_5pcty      svy
mkrow r_sch_schcall_2y_pr  pocy
mkrow r_sch_susp_2y_pr     pocy
mkrow w_fut_college        svy
mkrow w_fut_goodjob        svy

* Table G7
mkrow h_exer_arobx_fdw_yt  svy
mkrow h_exer_noswet_fdw_yt svy
mkrow sn_peer_sport_sr     svy
mkrow h_nutri_veg_fdw_ch   svy
mkrow atrigger             svy
mkrow h_care_insur_pr      svy
mkrow talkdoc              svy

* Table G8
mkrow svy_cmove	           svy
mkrow mm_spmove_all        svy
mkrow nmoves_sr1           svy
mkrow mm_spmove_all2       svy
mkrow nmoves_sr2           svy
mkrow mm_spmove_x_all      svy
mkrow nmoves_sr            svy


************************* INTERACT ADULTS BY GENDER COMP OF CHILDREN ************************
*
* In Tables G2-G8, variables from parental reports [PR] had analysis conducted 
* using household average right hand side variables
*

tempfile f
sort ppid
save `f'

global cellvars neighsat unsafe_n probs_n m_victim_6mos_nomis houscond probs_h h_env_int_idxob h_env_ext_idxob eatall schv nb_monit_graffiti_ad nb_monit_skipsch_ad nmoves_sr* 

tempfile g
use famid svy_sample $cellvars using ../derived_aca2/aca_vars if svy_sample=="AD"
sort famid
save `g'

use ../create_mto/mtowgts_040303, clear

sort ppid
merge ppid using ../create_mto/mtocov_040803

gen z_svy_age_dec2001 = 2001-year(svy_dob_i)

keep if inrange(z_svy_age_dec2001,15,20) 
keep if svy_sample=="CH"

gen svy_gender2 = 0 if svy_gender=="F"
replace svy_gender2 = 1 if svy_gender=="M"
replace svy_gender2 = .5 if svy_gender==""

drop x_ch_age*
run ~/kling/lg
lg 6 svy_dob_i x_cage

keep famid wt_totpocy svy_gender2 x_c*

collapse (sum) wt_totcells = wt_totpocy (mean) x_c* svy_gender2, by(famid)
save agg, replace

use `f', clear
drop svy_gender2 x_c* wt_totcells
keep if svy_sample=="AD"
sort famid
merge famid using agg
drop if svy_gender2==.
drop _m x_c2* x_ch_bl_age617

drop $cellvars
sort famid
merge famid using `g', nokeep
drop _m

foreach v of varlist x_* {
 replace xf_`v' = `v'
 replace xm_`v' = 0
}

forvalues i=1/5 {
 forvalue j=1/2 {
  replace sgf_`j'`i' = (ra_group==`j' & ra_site==`i' ) * svy_gender2
  replace sgm_`j'`i' = (ra_group==`j' & ra_site==`i' ) * (1-svy_gender2)
 }
}

foreach g in f m {
 if "`g'"=="f" {
  local m 1-
 }
 else {
  local m 
 }
 replace e`g'_itt = (ra_group==1 ) * (`m' svy_gender2) if ra_group!=2
 replace s`g'_itt = (ra_group==2 ) * (`m' svy_gender2) if ra_group!=1
 replace e`g'_tot = (ra_group==1 & svy_cmove==1) * (`m' svy_gender2) if ra_group!=2
 replace s`g'_tot = (ra_group==2 & svy_cmove==1) * (`m' svy_gender2) if ra_group!=1
 replace p`g'_ols  = $p * (`m' svy_gender2)
 replace p`g'_iv  = $p * (`m' svy_gender2)
 replace p`g'_iv2 = svy_cmove * (`m' svy_gender2)
}



foreach v of varlist svy_cmove $cellvars h_ment_distk6z_ad h_ment_depprobadl2_y_bad h_ment_anxiety_y_ad h_ment_calm h_ment_sleep_78hrs {
 mkrow `v' cells
}



